100 REM-PROGRAM TO CALC TIME TO COOL <or heat> TANK OF WATER
200 CLS
300 PRINT"THIS PROGRAM WILL CALCULATE THE TIME TO COOL <or heat> A TANK OF WATER STARTING AT SOME INITIAL TEMPERATURE. THE USER INPUTS AMBIENT TEMPERATURE AS WELL AS DIMENSIONS OF THE TANK.
400 PRINT"THE FOLLOWING ASSUMPTIONS ARE MADE:"
500 PRINT"    1.TANK IS VERTICAL,CYLINDRICAL VESSEL,OPEN AT THE TOP,AND PERFECTLY INSULATED OTHERWISE."
600 PRINT"    2.THE TANK AND INSULATION HAVE NEGLIGIBLE HEAT CAPACITY."
700 PRINT"    3.AMBIENT TEMPERATURE VARIES SINUSOIDALLY WITH TIME,HAVING A PERIOD OF 24 HOURS.CALC STARTS WITH MAXIMUM TEMP AT TIME EQUALS ZERO."
800 PRINT"    4.THE TANK IS PERFECTLY MIXED AT ALL TIMES."
900 PRINT"    5.NOTE-FOR CONSTANT AMBIENT TEMP, INPUT SAME TEMPS FOR MAX AND MIN."
1000 PRINT"    6.NOTE-FOR LIQUID OTHER THAN WATER,RETYPE LINE 2200 WITH NEW PHYSICAL PROPERTIES."
1100 B$="":IF INKEY$=B$ THEN 1100 ELSE 1150
1150 CLS
1200 INPUT"TANK DIAMETER,FT.=";D:LPRINT"TANK DIAM="D" FEET"
1300 INPUT"TANK HEIGHT,FT.=";H:LPRINT"TANK HEIGHT="H" FEET"
1400 INPUT"INITIAL TEMP OF LIQUID IN TANK,DEGREES F=";T:LPRINT"INITIAL TEMP OF LIQUID IN TANK="T" DEGREES F"
1500 INPUT"MAX AMBIENT TEMP,DEGREES F=";T1:LPRINT"MAX AMBIENT TEMP="T1" DEGREES F"
1600 INPUT"MIN AMBIENT TEMP,DEGREES F=";T2:LPRINT"MIN AMBIENT TEMP="T2" DEGREES F"
1700 PRINT:LPRINT" "
1800 REM-DEFINE CONSTANTS <HTC=HEAT TRANSFER COEFFICIENT,BTU/(HR*FT2*DEG F)>   <DEN=DENSITY,LB/FT3>   <CP=SPECIFIC HEAT,BTU/(LB*DEG F)>  <DT=TIME INCREMENT,HOURS>
1900 DT=.125
2000 PI=3.14159
2200 HTC=2.5:DEN=62.4:CP=1.0
2300 REM-<F EQUALS (HTC)(A)/(W)(CP)> WHERE A=X-SECTIONAL AREA,W=WEIGHT OF LIQUID IN TANK
2400 A=PI*(D/2)[2: W=A*H*DEN
2500 F=HTC*A/(W*CP)
2600 S=(T1-T2)/2: R=(T1+T2)/2
2700 PRINT"TIME,HOURS     LIQUID TEMP,F    AIR TEMP,F"
2800 FOR I=1 TO 45:PRINT"-";:IF I=45 PRINT" " ELSE NEXT I
2900 LPRINT"TIME,HOURS     LIQUID TEMP,F     AIR TEMP,F"
3000 FOR I=1 TO 45:LPRINT"-";:IF I=45 LPRINT" " ELSE NEXT I
3100 A$=" ###.#          ###.##           ###.#"
3200 REM-CALC NEW TEMPS
3300 TAMB=S*SIN(.083333*PI*TM+PI/2)+R
3400 K=F*(T-TAMB)*DT : REM-CHANGE IN LIQUID TEMP
3500 IF INT(TM/2)=TM/2 THEN 3600 ELSE 3800
3600 PRINT USING A$;TM,T,TAMB
3700 LPRINT USING A$;TM,T,TAMB
3800 T=T-K : REM-NEW LIQUID TEMP,F
3900 TM=TM+DT : REM-TM=TIME,HOURS
4000 GOTO 3300
